#!/bin/ksh
#############################
# create tpch database
#############################
echo Start Database Creation at `date`

sqlplus / as sysdba<<EOF
set echo on
set timing on

shutdown abort;

startup pfile=?/dbs/inittpch.ora nomount;
create database
  controlfile reuse
  set default bigfile tablespace
  logfile '/dev/md/rdsk/d251' size 130000m reuse,
          '/dev/md/rdsk/d252' size 130000m reuse,
          '/dev/md/rdsk/d253' size 130000m reuse
  datafile '/dev/md/rdsk/d254'
           size 4000m reuse
  sysaux datafile '/dev/md/rdsk/d255'
           size 20000m reuse
  smallfile undo tablespace ts_undo
       datafile  '/dev/md/rdsk/d256'
         size 5000m reuse
  default temporary tablespace ts_temp
       tempfile '/dev/md/rdsk/d90'
          size 3000000m reuse
       extent management local uniform size 10m
  maxdatafiles 2000
  maxinstances 1
;

set termout off
set echo off
spool /tmp/cat
@?/rdbms/admin/catalog.sql;
@?/rdbms/admin/catparr.sql;
@?/rdbms/admin/catproc.sql;
@?/rdbms/admin/utlxplan.sql;

connect system/manager
@?/sqlplus/admin/pupbld.sql;
exit;
EOF

echo End Database Creation at `date`
