#!/bin/ksh
#############################################################################
# Schema Creation Phase - datafiles only (no tables or users)
# creating data tablespaces, datafiles
# creating tpch's ts_default tablespace
#############################################################################

echo START Tablespace Creation at `date`

# create ts_default tablespace
sqlplus / as sysdba<<!
set echo on;
set timing on;

drop user tpch cascade;
grant DBA
to tpch identified by tpch;

drop tablespace ts_default including contents and datafiles;
create tablespace ts_default
datafile '/dev/md/rdsk/d257' size 10200m reuse
extent management local autoallocate ;
exit;
!

# create ts_s tablespace
sqlplus / as sysdba<<! &
set echo on;
set timing on;
drop tablespace ts_s including contents and datafiles;
create tablespace ts_s
datafile '/dev/md/rdsk/d258' size 6000m reuse
extent management local autoallocate nologging ;
exit;
!
sleep 2

# create ts_c tablespace
sqlplus / as sysdba<<! &
set echo on;
set timing on;
drop tablespace ts_c including contents and datafiles;
create tablespace ts_c
datafile '/dev/md/rdsk/d259' size 80000m reuse
extent management local autoallocate nologging ;
exit;
!
sleep 2

# create ts_o tablespaces
sqlplus / as sysdba<<! &
set echo on;
set timing on;
drop tablespace ts_o including contents and datafiles;
create tablespace ts_o
datafile '/dev/md/rdsk/d260' size 700000m reuse
extent management local autoallocate nologging  ;
exit;
!
sleep 2

# create ts_ps tablespace
sqlplus / as sysdba<<! &
set echo on;
set timing on;
drop tablespace ts_ps including contents and datafiles;
create tablespace ts_ps
datafile '/dev/md/rdsk/d261' size 400000m reuse
extent management local autoallocate nologging ;
exit;
!
sleep 2

# create ts_p tablespace
sqlplus / as sysdba<<! &
set echo on;
set timing on;
drop tablespace ts_p including contents and datafiles;
create tablespace ts_p
datafile '/dev/md/rdsk/d262' size 60000m reuse
extent management local autoallocate nologging ;
exit;
!
sleep 2

# create ts_l tablespace
sqlplus / as sysdba<<! &
set echo on;
set timing on;
drop tablespace ts_l including contents and datafiles;
create tablespace ts_l
datafile '/dev/md/rdsk/d263' size 2200000m reuse
extent management local autoallocate nologging;
exit;
!
sleep 2

# create ts_idx tablespace
sqlplus / as sysdba<<! &
set echo on;
set timing on;
drop tablespace ts_idx including contents and datafiles;
create tablespace ts_idx
datafile '/dev/md/rdsk/d264' size 1023000m reuse
extent management local autoallocate nologging ;
exit;
!
sleep 2

# adding tpch's ts_undo datafiles
let i=265
while ((i<=276))
do
sqlplus / as sysdba<<! &
set echo on;
set timing on;
alter tablespace ts_undo
  add datafile '/dev/md/rdsk/d$i' size 128500m reuse;
exit;
!
let i+=1
done

wait

echo END Tablespace Creation at `date`
